# UTMDriver
## Описание
Данный модуль предназначен для интеграции пользовательских приложений с ФСРАР УТМ

Этот модуль представляет собой набор классов и вспомогательных функций для прямой работы с УТМ
## Установка
Клонируем репозиторий в окружение
```
$ git clone https://github.com/maxpoint2point/UTMDriver.git
```
Далее необходимо установить зависимости
## Использование
Импортируем модуль
```
from UTMDriver import Connector
```
Создаем экземпляр УТМ
```
utm = Connector('localhost', 8080)
```
где первый аргумент хост (допускается использование ip), второй порт
* Получение всех документов из базы УТМ
```
utm.getAll()
```
* Получение документов по типу
```
utm.getByType('Ticket')
```
* Получение документов по адресу
```
utm.getByUrl('http://localhost:8080/opt/out/Ticket/5')
```
допускается использование относительного адреса
```
utm.getByUrl('Ticket/5')
```
* Получение документов по ReplyId
```
utm.getByReplyId('7002e49c-5f63-4fdc-8bc7-5a6f8dcda041')
```
Вернет все документы, связанные этим ReplyId

## Отправка исходящих документов
Данный модуль поддерживает отправку некоторых стандартных типов документов в ЕГАИС

Отправка осуществляется с помощью метода класса.
Например, акт списания из торгового зала
```
utm.request_document('ActWriteOfShop_v2', positions=positions, number=4, reason='Иные цели')
```
где переменная позиции может быть списком словарей, содержащий обязательные ключи:
```
positions = {
            'full_name': 'Напиток "Blanche biere Пшеничное Белое" ("Бланш Бир Пшеничное Белое")',
            'alc_code': '0000000000031584366',
            'capacity': 0,
            'unit_type': '',
            'alc_volume': 4.8,
            'v_code': 520,
            'Producer_regId': '030000000042',
            'Producer_inn': '7802849641',
            'Producer_kpp': '366543001',
            'Producer_fullName': 'ОБЩЕСТВО С ОГРАНИЧЕННОЙ ОТВЕТСТВЕННОСТЬЮ "ПИВОВАРЕННАЯ КОМПАНИЯ "БАЛТИКА"',
            'Producer_shortName': 'ООО "ПИВОВАРЕННАЯ КОМПАНИЯ "БАЛТИКА"',
            'country': 643,
            'region': 36,
            'address': '394019, РОССИЯ, , , Г ВОРОНЕЖ, , УЛ 9 ЯНВАРЯ, 109, ,',
            'quantity': 20,
        }
```
Полное описание API Будет в документации